import { describe, expect, test } from '@jest/globals';

import TokenService from '../../../app/services/token.service';
import CreateTokenRequest from '../../../app/requests/token/create-token.request';
import { ITokenRequestCreateOne } from '../../../app/common/interfaces/requests/token.request';
import { Token } from '../../../app/models/token.model';

describe("Token Service", () => {
  let tokenService: TokenService;
  let tokenRequest: CreateTokenRequest;

  const params: ITokenRequestCreateOne = {
    cvv: 777,
    expiration_month: "7",
    expiration_year: "2025",
    card_number: 4556364607935616,
    email: "genaro010204@gmail.com",
  }

  beforeEach(() => {
    tokenService = new TokenService()
    tokenRequest = new CreateTokenRequest(params)
  })

  test("Should be defined", () => {
    expect(tokenService).toBeDefined()
  })

  test("Should be instance of TokenService", () => {
    expect(tokenService).toBeInstanceOf(TokenService)
  })

  test("Should mask card number", () => {
    const tokenBuilt = tokenService.buildOne(params)
    
    expect(tokenBuilt.card_number).not.toEqual(params.card_number)
  })
  
  test("Should not be expired", () => {
    const tokenBuilt = tokenService.buildOne(params)
    tokenBuilt.auto_generated_token = "4qbg2r3oS4QasfpC"
    tokenBuilt.expiration_date_token = new Date("2023-07-03T02:15:28.648Z")

    expect(tokenBuilt.expired).not.toEqual(true)
    expect(tokenBuilt).toEqual({
      cvv: 777,
      email: "genaro010204@gmail.com",
      expired: false,
      card_number: "455636******5616",
      expiration_date_token: new Date("2023-07-03T02:15:28.648Z"),
      expiration_year: "2025",
      expiration_month: "7",
      auto_generated_token: "4qbg2r3oS4QasfpC",
    })
  })

  test("Should create one token", async() => {
    const tokenServiceSpy  = jest.spyOn(tokenService, 'createOne')
    const mockToken: CreateTokenRequest = {
      cvv: 777,
      expiration_month: "7",
      expiration_year: "2025",
      card_number: 4556364607935616,
      email: "genaro010204@gmail.com",
    }
    
    const mockTokenCreated: Token = {
      cvv: 777,
      expiration_month: '7',
      expiration_year: '2025',
      card_number: 4556364607935616,
      email: 'genaro010204@gmail.com'
    } as any as Token

    tokenServiceSpy.mockResolvedValueOnce(mockToken as any)

    const savedToken = await tokenService.createOne(mockToken);

    expect(tokenServiceSpy).toHaveBeenCalledWith(mockToken);
    expect(savedToken).toBeDefined()
    expect(savedToken).toEqual(mockTokenCreated);

    tokenServiceSpy.mockRestore()
  })

  test("Should save one token", async() => {
    const tokenServiceSpy  = jest.spyOn(tokenService, 'saveOne')
    const mockToken: Token = {
      cvv: 777,
      email: "genaro010204@gmail.com",
      expired: false,
      card_number: "455636******5616",
      expiration_date_token: new Date("2023-07-03T02:15:28.648Z"),
      expiration_year: "2025",
      expiration_month: "7",
      auto_generated_token: "4qbg2r3oS4QasfpC",
    }

    tokenServiceSpy.mockResolvedValueOnce(mockToken as any)

    const savedToken = await tokenService.saveOne(mockToken);

    expect(tokenServiceSpy).toHaveBeenCalledWith(mockToken);
    expect(savedToken).toEqual(mockToken);

    tokenServiceSpy.mockRestore()
  })

  test("Should find one by auto generated token", async() => {
    const tokenServiceSpy  = jest.spyOn(tokenService, 'findOneByAutoGeneratedToken')
    
    const mockAutoGeneratedToken = "4qbg2r3oS4QasfpC"
    const mockToken = {
      cvv: 777,
      email: "genaro010204@gmail.com",
      expired: false,
      card_number: "455636******5616",
      expiration_date_token: new Date("2023-07-03T02:15:28.648Z"),
      expiration_year: "2025",
      expiration_month: "7",
      auto_generated_token: "4qbg2r3oS4QasfpC",
    }

    tokenServiceSpy.mockResolvedValueOnce(mockToken)

    const tokenFound = await tokenService.findOneByAutoGeneratedToken(mockAutoGeneratedToken);

    expect(tokenServiceSpy).toHaveBeenCalledWith(mockAutoGeneratedToken);
    expect(tokenFound).toEqual(mockToken);

    tokenServiceSpy.mockRestore()
  })
})